/* 
 * $Id: dmlwrapper.c,v 1.1 2001/10/14 08:43:28 pawelk Exp $
 * Author: Pawel Kolodziej <pawelk@pld.org.pl>
 * GNU license
 */
#include "../other/temp.h"
#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include "../cfile.h"
#include "../net/net.h"
#include <string.h>
#include <unistd.h>
#include <stdlib.h>

void die(char *c)
{
	printf("DIE: %s\n",c);
	exit(1);
}

struct phash * runDml(char *txt)
{
	int fd;
	char *fname, cmd[1000];
	FILE *out;
	struct phash *ret;

	fname = getTempFileName(getTmp(), "wuch_grade_dml");
	if(fname==NULL || (fd=open(fname,O_CREAT | O_EXCL | O_WRONLY,
					S_IRUSR | S_IWUSR ))==-1)
		die("can't create tmp file !!!");
	write(fd, txt, strlen(txt));
	close(fd);
	sprintf(cmd, "dml -f %s",fname);
	out = popen(cmd, "r");
	ret = ph_new();
	while(!feof(out)){
		char line[10000], *value;
		fgets(line, 9999,out);
		line[strlen(line)-1]='\0';
		value=strchr(line,'=');
		if(value == NULL)
			continue;
		*value='\0';
		value++;
		if(value[0]=='"'){
			value++;
			value[strlen(value)-1]='\0';
		}
/*		printf("mam linie %s##%s&&\n",line, value);  */
		pkt_add_string(ret, line, value);
	}
	pclose(out);
	unlink(fname);
	free(fname);

	return ret;
}
	
#if 0
main()
{
	pkt_send(1,runDml("pupa <button text=ohhno>"));
}

#endif 
