#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#include "bug.h"
#include "mess.h"
#include "cfile.h"

Tbug* bugNew(TpkgDescribe *pkg, TpkgDescribe *env, int envCount)
{
	Tbug *ret;
	int i;
	
	ret = malloc(sizeof(Tbug));
	ret->pkg=pkg->name;
	ret->evr=pkg->evr;
	ret->text=strdup("");
	ret->title=strdup("");
	ret->cathegory=1;
	ret->automatic=malloc(envCount*100 + 1000);
	
	strcpy(ret->automatic,"Folowing packages are installed in my system\n");

	for(i=0; i<envCount; i++){
		strcat(ret->automatic,env[i].name);
		strcat(ret->automatic,"-");
		strcat(ret->automatic,env[i].evr);
		strcat(ret->automatic,"\n");
	}
	return ret;
}
char * bugMessage(Tbug *bug)
{
	char *ret;
	char buf[10000];

	ret = malloc(strlen(bug->text) + strlen(bug->title) + strlen(bug->automatic));
	strcpy(ret,"");
	sprintf(buf,"CID: %d\n",bug->cathegory);	strcat(ret,buf);
	sprintf(buf,"EMAIL: %s\n",getMopEmail());	strcat(ret,buf);
	sprintf(buf,"PKG: %s\n",bug->pkg);		strcat(ret,buf);
	sprintf(buf,"EVR: %s\n",bug->evr);		strcat(ret,buf);
	sprintf(buf,"TITLE: %s\n",bug->title);	strcat(ret,buf);
	sprintf(buf,"TEXT:\n %s\n\n<<--<<--",bug->text);	strcat(ret,buf);
	sprintf(buf,"AUTO:\n %s\n\n<<--<<--",bug->automatic);strcat(ret,buf);
	return NULL;
}
	
	

	
			
